; Bernhard.Erfurt@gmx.de						
; 01/2021										
;												
;												
; 128 x 64 Pixel=8.192 Pixel :8=1024			
; ATmega8 										
; 8MHz											
.include "m8def.inc"
.include "MACROS.asm"
; ERROR CODES									
.equ ERROR_TWI_MT_START			=0x20
.equ ERROR_TWI_MT_SLA			=0x21
.equ ERROR_TWI_MT_DATA			=0x22
.equ ERROR_TWI_MR_START			=0x23
.equ ERROR_TWI_MR_SLA			=0x24
.equ ERROR_TWI_MR_DATA			=0x25
.equ ERROR_TWI_MR_DATAEND		=0x26

; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START		; 0x0060 START Adresse 						
.equ adr_TWI_BEREICH_READ			= SRAM_START+200	; BEREICH fr Master TWI/I2C	
.equ adr_SRAM_CHECK					= SRAM_START+900	; Programm-Check	

; REGISTER										
.def ERROR	= R10
.def NULL 	= R14
.def EINS 	= R15
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler       		
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Interrupt-ERROR ==> NEUSTART						
INTERRUPT_ERROR:
	WDR
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rjmp INTERRUPT_ERROR
RESET:                        
	ldi temp, LOW(RAMEND)						; STACK initialisieren
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall Watchdog_aktivieren
	rcall SRAM_CLEAR
	rcall STARTWERTE
	rcall PORT_CLEAR
	rcall PORT_INITIALISIERUNG
	rcall TWI_INI
	rcall PROGRAMM_CHECK
	sei											; interrupts freigeben
;-------------------------------------------------------------------------------
	rcall WAIT_1s
	rcall TWI_OLED_INITIALISIERUNG
	rcall WAIT_1s
	LED_GRUEN_ON
	rcall WAIT_1s
;	rcall STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	wdr
	rcall PROGRAMM_CHECK
	rcall OLED_VOLL
	rcall WAIT_1s
	rcall OLED_CLEAR
	rcall WAIT_1s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SONSTIGES.asm"
.include "WAIT.asm"
.include "TWI.asm"
.include "TWI_OLED.asm"

